{$R-}
unit huffman;

(* Mthodes
      Compression normale   : 0
      Compression variation : 1
      Pas de compression    : 2
*)

INTERFACE

procedure RZIP(sname,dname:string);
procedure RDEZIP(sname,dname:string);


IMPLEMENTATION
type Tsigne=array [0..3] of char;
     Pnoeud=^Tnoeud;
     Tnoeud=record
              carac:byte;
              cumul:longint;
              Fdroit,Fgauche:Pnoeud;
            end;
     Tcode=record
             long:byte;
             bits:longint;
           end;
     Tfullcode=array [0..255] of Tcode;
     Tfrequence=array [0..255] of longint;
const signature:Tsigne='RZIP';
      buffer_size=10000;
var sfic,dfic:file;
(*** THA HEADER ***)
    signe:Tsigne;
    method:word;
    frequence:Tfrequence;
    fsize:longint;
(*** END HEADER ***)
    buffer_read,buffer_writ:array [1..buffer_size] of byte;
    pos_read,pos_writ,numread:word;
    arbre:Pnoeud;
    code:Tfullcode;
    temp_code:Tcode;
    bd:byte;  (* pour les barre dfilement *)
    old:byte; (* pour variation method *)

procedure make_code(data:Pnoeud);
begin
  with data^ do begin
    if (Fgauche=nil) and (Fdroit=nil) then code[carac]:=temp_code;
    inc(temp_code.long);
    temp_code.bits:=temp_code.bits shl 1;
    if Fgauche<>nil then make_code(Fgauche);
    temp_code.bits:=temp_code.bits+1;
    if Fdroit<>nil then make_code(Fdroit);
    temp_code.bits:=temp_code.bits shr 1;
    dec(temp_code.long);
  end;
end;

procedure make_arbre;
var tab:array [0..255] of Pnoeud;
    temp:Pnoeud;
    tab_size:integer;
    i,j,k:byte;
begin
(*** initialize ze tableau ***)
  tab_size:=0;
  for i:=0 to 255 do if frequence[i]>0 then begin
    new(tab[tab_size]);
    with tab[tab_size]^ do begin
      carac:=i;
      cumul:=frequence[i];
      Fgauche:=nil;
      Fdroit:=nil;
    end;
    inc(tab_size);
  end;
  dec(tab_size);
(*** Tri ***)
  for i:=0 to tab_size do begin
    j:=i;
    for k:=i+1 to tab_size do if tab[k]^.cumul>tab[j]^.cumul then j:=k;
    temp:=tab[i];
    tab[i]:=tab[j];
    tab[j]:=temp;
  end;
(*** Make za arbre ***)
  while tab_size>0 do begin
    dec(tab_size);
    new(temp);
    temp^.Fgauche:=tab[tab_size];
    temp^.Fdroit :=tab[tab_size+1];
    temp^.cumul  :=tab[tab_size]^.cumul+tab[tab_size+1]^.cumul;
    tab[tab_size]:=temp;
(*** Find place and swap ***)
    for i:=0 to tab_size do begin
      j:=i;
      for k:=i+1 to tab_size do if tab[k]^.cumul>tab[j]^.cumul then j:=k;
      temp:=tab[i];
      tab[i]:=tab[j];
      tab[j]:=temp;
    end;
    {30.59
    i:=0;
    while (temp^.cumul<tab[i]^.cumul) and (i<tab_size) do inc(i);
(*** i=tab_size ou i=position a inserer ***)
    for j:=tab_size downto i+1 do tab[j]:=tab[j-1];
    tab[i]:=temp;}
  end;
(*** TAB[0] iz it !!! ***)
  arbre:=tab[0];
end;

procedure RZIP(sname,dname:string);
var c(*caractre courant*),cur_writ_bit,cur_code_bit:byte;
    total0,total1,bits:longint;
    code_temp:Tfullcode;
    frequence_temp:Tfrequence;

procedure gocode(methode:word);
begin
  reset(sfic,1);
  fillchar(frequence,256*4,0);
  old:=0;
  repeat
    blockread(sfic,buffer_read,buffer_size,numread);
    for pos_read:=1 to numread do
      if methode=0 then inc(frequence[buffer_read[pos_read]])
      else begin
        inc(frequence[byte(old-buffer_read[pos_read])]);
        old:=buffer_read[pos_read];
      end;
  until numread<buffer_size;
(*** Fabriquer le code ***)
  make_arbre;
  temp_code.long:=0;
  make_code(arbre);
end;

begin
  writeln('Packing...');
  writeln('Source      : ',sname);
  writeln('Destination : ',dname);
  assign(sfic,sname);
{$i-}
  reset(sfic,1);
{$i+}
  if ioresult<>0 then begin writeln('Error : can''t open ',sname,' !'); exit; end;
(*** Calculer les 2 codes possibles ***)
  fsize:=filesize(sfic);
  writeln('Trying normal method...');
  gocode(0);
  total0:=0;
  for c:=0 to 255 do inc(total0,frequence[c]*code[c].long);
  frequence_temp:=frequence;
  code_temp:=code;
  writeln('Trying variation method...');
  gocode(1);
  total1:=0;
  for c:=0 to 255 do inc(total1,frequence[c]*code[c].long);
  if (total0 div 8+256*5+4>=fsize) and (total1 div 8+256*5+4>=fsize) then method:=2
  else if total0<=total1 then begin
    method:=0;
    code:=code_temp;
    frequence:=frequence_temp;
  end else method:=1;
(*** Compakt za file ***)
  reset(sfic,1);
  assign(dfic,dname);
{$i-}
  rewrite(dfic,1);
{$i+}
  if ioresult<>0 then begin writeln('Error : can''t create ',dname,' !'); exit; end;
  case method of
    0:writeln('Using normal method...');
    1:writeln('Using variation method...');
    2:writeln('Using non-compression method...');
  end;
(*** Write za header ***)
  signe:=signature;
  blockwrite(dfic,signe,4+2);
(*** If compressed method write code and filesize ***)
  if method<>2 then blockwrite(dfic,frequence,256*4+4);
(*** GO ***)
  write('Working [          ]');
  cur_writ_bit:=0;
  pos_writ:=1;
  old:=0;
  repeat
    blockread(sfic,buffer_read,buffer_size,numread);
(*** All za buffer ***)
    if method<>2 then for pos_read:=1 to numread do begin
      c:=buffer_read[pos_read];
      if method=1 then begin
        c:=old-c;
        old:=buffer_read[pos_read];
      end;
(*** Test for code bits ***)
{      bits:=1 shl (code[c].long-1);}
      bits:=1;
      for bd:=1 to code[c].long-1 do bits:=bits shl 1;
      for cur_code_bit:=1 to code[c].long do begin
(*** Write next bit ***)
        buffer_writ[pos_writ]:=buffer_writ[pos_writ] shl 1;
(*** 0/1 ***)
        if bits and code[c].bits<>0 then inc(buffer_writ[pos_writ]);
        bits:=bits shr 1;
(*** done ***)
        inc(cur_writ_bit);
        if cur_writ_bit>7 then begin
          cur_writ_bit:=0;
          if pos_writ=buffer_size then begin
            pos_writ:=0;
            blockwrite(dfic,buffer_writ,buffer_size);
          end;
          inc(pos_writ);
        end;
      end;
    end else blockwrite(dfic,buffer_read,numread);

(*** Barre ***)
  write(#8#8#8#8#8#8#8#8#8#8#8#8'[');
  for bd:=1 to 10 do begin
    if filesize(sfic)=0 then write('')
    else if bd<=10*filepos(sfic)/filesize(sfic) then write('')
    else write(' ');
  end;
  write(']');

  until numread<buffer_size;
  if method<>2 then begin
    buffer_writ[pos_writ]:=buffer_writ[pos_writ] shl (8-cur_writ_bit);
    blockwrite(dfic,buffer_writ,pos_writ);
  end;
  writeln;
  write('Taux : ');
  if fsize<>0 then writeln(100-100*filesize(dfic)/filesize(sfic):2:2,' %')
              else writeln('N.S. !!!');
  close(sfic);
  close(dfic);
end;

procedure RDEZIP(sname,dname:string);
var bits,cur_read_bit:byte;
    cur_code:Pnoeud;
begin
  writeln('Unpacking...');
  writeln('Source      : ',sname);
  writeln('Destination : ',dname);
  assign(sfic,sname);
{$i-}
  reset(sfic,1);
{$i+}
  if ioresult<>0 then begin writeln('Error : can''t open ',sname,' !'); exit; end;
(*** Read za header ***)
  blockread(sfic,signe,4+2);
  if (signe<>signature) or not (method in [0..2]) then begin
    writeln('Error : ',sname,' iz not a valid archive !');
    close(sfic);
    exit;
  end;
  if method<>2 then begin
    blockread(sfic,frequence,256*4+4);
    make_arbre;
  end;
  assign(dfic,dname);
{$i-}
  rewrite(dfic,1);
{$i+}
  if ioresult<>0 then begin writeln('Error : can''t create ',dname,' !'); exit; end;
(*** GO ***)
  write('Working [          ]');
  cur_code:=arbre;
  pos_writ:=1;
  old:=0;
  repeat
    blockread(sfic,buffer_read,buffer_size,numread);
    if method<>2 then for pos_read:=1 to numread do begin
      bits:=128;
      for cur_read_bit:=0 to 7 do begin
        if bits and buffer_read[pos_read]=0 then cur_code:=cur_code^.fgauche
                                            else cur_code:=cur_code^.fdroit;
        bits:=bits shr 1;
        if cur_code^.fgauche=nil then begin
          if method=0 then buffer_writ[pos_writ]:=cur_code^.carac
                      else begin
                             buffer_writ[pos_writ]:=old-cur_code^.carac;
                             old:=buffer_writ[pos_writ];
                           end;
          if pos_writ=buffer_size then begin
            pos_writ:=0;
            blockwrite(dfic,buffer_writ,buffer_size);
          end;
          inc(pos_writ);
          cur_code:=arbre;
        end;
      end;
    end else blockwrite(dfic,buffer_read,numread);

(*** Barre ***)
  write(#8#8#8#8#8#8#8#8#8#8#8#8'[');
  for bd:=1 to 10 do begin
    if bd<=10*filepos(sfic)/filesize(sfic) then write('')
                                           else write(' ');
  end;
  write(']');

  until numread<buffer_size;
  if method<>2 then begin
    blockwrite(dfic,buffer_writ,pos_writ);
    seek(dfic,fsize);
    truncate(dfic);
  end;
  close(sfic);
  close(dfic);
  writeln;
end;

end.